Selector that filters files based on whether they contain a particular string.

It provides support for gathering the parameters together as well as for assigning an error message and throwing a build exception if an error is detected.

author | Hans Lellelid <hans@xmpl.org> (Phing)
author | Bruce Atherton <bruce@callenish.com> (Ant)
package | phing.types.selectors
version | $Id$

### Methods

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference()

Inherited

inherited_from | \DataType::circularReference()
inherited_from | \BaseSelector::circularReference()
inherited_from | \BaseExtendSelector::circularReference()

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference($stk, \Project $p)

Inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

inherited_from | \DataType::dieOnCircularReference()
inherited_from | \BaseSelector::dieOnCircularReference()
inherited_from | \BaseExtendSelector::dieOnCircularReference()

### Parameters

#### $stk

#### $p

## Performs the check for circular references and returns the referenced object.

    getCheckedRef($requiredClass, $dataTypeName)

Inherited

inherited_from | \DataType::getCheckedRef()
inherited_from | \BaseSelector::getCheckedRef()
inherited_from | \BaseExtendSelector::getCheckedRef()

### Parameters

#### $requiredClass

#### $dataTypeName

## Return the description for the current data type.

    getDescription()

Inherited

inherited_from | \DataType::getDescription()
inherited_from | \BaseSelector::getDescription()
inherited_from | \BaseExtendSelector::getDescription()

## Returns any error messages that have been set.

    getError() : \the

Inherited

inherited_from | \BaseSelector::getError()
inherited_from | \BaseExtendSelector::getError()

### Returns

`\the`error condition

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \DataType::getProject()
inherited_from | \BaseSelector::getProject()
inherited_from | \BaseExtendSelector::getProject()

### Returns

`\Project`Reference to current porject object

## Has the refid attribute of this element been set?

    isReference()

Inherited

inherited_from | \DataType::isReference()
inherited_from | \BaseSelector::isReference()
inherited_from | \BaseExtendSelector::isReference()

## The heart of the matter.

    isSelected(\PhingFile $basedir, \filename $filename, \PhingFile $file) : \whether

This is where the selector gets to decide on the inclusion of a file in a particular fileset.

### Parameters

#### $basedir

`\basedir`

the base directory the scan is being done from

#### $filename

`\filename`

is the name of the file to check

#### $file

`\file`

a PhingFile object the selector can use

### Exceptions

`\BuildException` | if the selector was not configured correctly

### Returns

`\whether`the file should be selected or not

## Logs a message with the given priority.

    log(string $msg, integer $level)

Inherited

inherited_from | \ProjectComponent::log()
inherited_from | \DataType::log()
inherited_from | \BaseSelector::log()
inherited_from | \BaseExtendSelector::log()

### Parameters

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed()

Inherited

inherited_from | \DataType::noChildrenAllowed()
inherited_from | \BaseSelector::noChildrenAllowed()
inherited_from | \BaseExtendSelector::noChildrenAllowed()

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

Inherited

inherited_from | \DataType::parsingComplete()
inherited_from | \BaseSelector::parsingComplete()
inherited_from | \BaseExtendSelector::parsingComplete()

## Whether to ignore case in the string being searched.

    setCasesensitive(boolean $casesensitive)

### Parameters

#### $casesensitive

`boolean`

whether to pay attention to case sensitivity

## Sets a description of the current data type.

    setDescription($desc)

Inherited

It will be useful in commenting what we are doing.

inherited_from | \DataType::setDescription()
inherited_from | \BaseSelector::setDescription()
inherited_from | \BaseExtendSelector::setDescription()

### Parameters

#### $desc

## Allows all selectors to indicate a setup error.

    setError(\msg $msg)

Inherited

Note that only the first error message is recorded.

inherited_from | \BaseSelector::setError()
inherited_from | \BaseExtendSelector::setError()

### Parameters

#### $msg

`\msg`

The error message any BuildException should throw.

## When using this as a custom selector, this method will be called.

    setParameters(array $parameters)

It translates each parameter into the appropriate setXXX() call.

### Parameters

#### $parameters

`array`

the complete set of parameters for this selector

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \DataType::setProject()
inherited_from | \BaseSelector::setProject()
inherited_from | \BaseExtendSelector::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

Inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

inherited_from | \DataType::setRefid()
inherited_from | \BaseSelector::setRefid()
inherited_from | \BaseExtendSelector::setRefid()

### Parameters

#### $r

`\Reference`

## The string to search for within a file.

    setText(string $contains)

### Parameters

#### $contains

`string`

the string that a file must contain to be selected.

## toString()

    toString()

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes()

Inherited

inherited_from | \DataType::tooManyAttributes()
inherited_from | \BaseSelector::tooManyAttributes()
inherited_from | \BaseExtendSelector::tooManyAttributes()

## Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.

    validate()

Inherited

inherited_from | \BaseSelector::validate()
inherited_from | \BaseExtendSelector::validate()

## Checks to make sure all settings are kosher.

    verifySettings()

In this case, it means that the pattern attribute has been set.

## Allows access to the parameters gathered and set within the &lt;custom&gt; tag.

    getParameters() : \the

Inherited

inherited_from | \BaseExtendSelector::getParameters()

### Returns

`\the`set of parameters defined for this selector

### Properties

##

    $description

Inherited

inherited_from | \DataType::$$description
inherited_from | \BaseSelector::$$description
inherited_from | \BaseExtendSelector::$$description

##

    $ref

Inherited

Type of Reference

inherited_from | \DataType::$$ref
inherited_from | \BaseSelector::$$ref
inherited_from | \BaseExtendSelector::$$ref

##

    $checked : boolean

Inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

inherited_from | \DataType::$$checked
inherited_from | \BaseSelector::$$checked
inherited_from | \BaseExtendSelector::$$checked

##

    $parameters

Inherited

inherited_from | \BaseExtendSelector::$$parameters

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \DataType::$$project
inherited_from | \BaseSelector::$$project
inherited_from | \BaseExtendSelector::$$project

##

    $casesensitive

##

    $contains

##

    $errmsg

Inherited

inherited_from | \BaseSelector::$$errmsg
inherited_from | \BaseExtendSelector::$$errmsg

### Constants

## CASE_KEY

    CASE_KEY

## CONTAINS_KEY

    CONTAINS_KEY